<script setup lang="ts">
import { onMounted, ref, nextTick } from "vue";
import { listingTypes } from "@/stores/listingTypes";
import { useRoute } from "vue-router"
import Swal from 'sweetalert2'
import { toast } from "vue3-toastify";
import { useI18n } from "vue-i18n"

const { t } = useI18n()

const route = useRoute()
let mainType = ref(5)

const listingTypesStorage = listingTypes();


function changeType(type) {
    mainType.value = type
    listingTypesStorage.FETCH_SUBE_TYPE_RELATION_FORM_LIST({ main_id: mainType.value, sub_id: route.params.id })
}

function checkIfCheckBoxDisabled(item) {
    let array = listingTypesStorage.listingTypesRelationFormsList.data.find(elem => elem.main)
    console.log(array)

    if (array) { // If there is any true in checkboxes
        if (item) {
            return false
        } else {
            return true
        }
    } else { // If there isn't true in checkboxes
        return false
    }
}


onMounted(async () => {
    listingTypesStorage.FETCH_SUBE_TYPE_RELATION_FORM_LIST({ main_id: mainType.value, sub_id: route.params.id })
})

const headers = [
    {
        text: "id",
        value: "form_id",
    },
    {
        text: "name",
        value: "name",
    },

    {
        text: "Status",
        value: "status",
    },

    {
        text: "actions",
        value: "actions"
    },
];

const headerItemClassNameFunction = (header): string => {
    if (header.value === "actions") return "float-right mr-12";
    return "";
};


async function disConnectForm(data) {
    try {
        Swal.fire({
            title: 'Are you sure?',
            text: "You won't be able to revert this!",
            icon: 'warning',
            showCancelButton: true,
            confirmButtonColor: '#3085d6',
            cancelButtonColor: '#d33',
            confirmButtonText: 'Yes, delete it!'
        }).then(async (result) => {
            if (result.isConfirmed) {
                await listingTypesStorage.DELETE_SUB_TYPE_RELATION_FORM({ relation_id: data.relation_id })
                toast.success("Success");
                await listingTypesStorage.FETCH_SUBE_TYPE_RELATION_FORM_LIST({ main_id: mainType.value, sub_id: route.params.id })

            }
        })
    } catch (error) {
        toast.error(error.response.data.msg ? error.response.data.msg : "Error");
    }
}

async function chengeStatus(result, relation_id) {
    console.log(relation_id);
    try {
        nextTick(async () => {
            await listingTypesStorage.CHANGE_STATUS_SUB_TYPE_RELATION_FORM({ relation_id: relation_id, main: result.target.checked })
            await listingTypesStorage.FETCH_SUBE_TYPE_RELATION_FORM_LIST({ main_id: mainType.value, sub_id: route.params.id })
            let a = listingTypesStorage.listingTypesRelationFormsList
            listingTypesStorage.listingTypesRelationFormsList = { data: [] }
            setTimeout(() => {
                console.log('2')
                listingTypesStorage.listingTypesRelationFormsList = a
            }, 0)
            console.log('1')
        })
        toast.success("Success");
    } catch (error) {
        toast.error(error.response.data.msg ? error.response.data.msg : "Error");
    }

}
</script>

<template>
    <div>

        <div class="flex items-center gap-2">
            <div class="w-1/4">
                <label for="search">
                    {{ t('Search') }}
                    <input id="search" type="text" class="form-input" :placeholder="t('Search')">
                </label>
            </div>

            <div class="w-1/4">
                <label for="state">
                    {{ t('State') }}
                    <v-select id="state" :options="books" label="title" class="!rounded-md mt-1"
                        :placeholder="t('State')" />
                </label>
            </div>


        </div>
        <div class="flex items-center mb-2 ">
            <button class="btn-success w-1/12 ml-auto"
                @click="$router.push({ name: 'add-form-type', query: { sub_id: route.params.id, main_id: mainType } })">{{
                    t('Add') }}</button>
        </div>
        <div>

            <div class="inline-flex mb-2">
                <button class="bg-gray-400 hover:bg-gray-400 text-white font-bold py-2 px-4 rounded-l"
                    :class="mainType == 5 ? '!bg-primary' : ''" @click="changeType(5)">
                    Жилье
                </button>
                <button class="bg-gray-400 hover:bg-gray-400 text-white font-bold py-2 px-4 rounded-r"
                    @click="changeType(4)" :class="mainType == 4 ? '!bg-primary' : ''">
                    Коммерческое
                </button>
            </div>

        </div>
        <!-- {{ listingTypesStorage.listingTypesRelationFormsList }} -->
        <EasyDataTable hide-footer :header-item-class-name="headerItemClassNameFunction" theme-color="#7367f0"
            :headers="headers" :items="listingTypesStorage.listingTypesRelationFormsList.data" id="user-table">

            <template #empty-message>
                <span>{{ t('empty_text') }}</span>
            </template>

            <template #header="data">
                {{ t(data.text) }}
            </template>

            <template #item-title="item">
                <span>{{ item.name }}</span>
            </template>

            <template #item-status="item">

                <label className="relative inline-flex items-center cursor-pointer">
                    <input type="checkbox" v-model="item.main" @input="chengeStatus($event, item.relation_id)"
                        :disabled="checkIfCheckBoxDisabled(item.main)" class="sr-only peer" />
                    <div
                        className="w-11 h-6 bg-gray-200 peer-focus:outline-none 
          rounded-full peer dark:bg-gray-700 peer-checked:after:translate-x-full peer-checked:after:border-white after:content-[''] after:absolute after:top-[2px] after:left-[2px] after:bg-white after:border-gray-300 after:border after:rounded-full after:h-5 after:w-5 after:transition-all dark:border-gray-600 peer-checked:bg-primary">
                    </div>
                </label>
            </template>


            <template #item-actions="item">
                <div class="float-right">
                    <button class="rounded-md bg-danger ml-3 px-3 py-1.5 text-white duration-100 hover:opacity-90"
                        @click="disConnectForm(item)">
                        <span uk-icon="icon: trash" class="uk-icon"></span>
                    </button>
                </div>
            </template>
        </EasyDataTable>
    </div>
</template>

<style></style>